HDU-6430:Problem E. TeaTree(bitset)

版权声明:http://blog.csdn.net/Mitsuha_。 https://blog.csdn.net/Mitsuha_/article/details/81951068

Problem E. TeaTree
Time Limit: 8000/4000 MS (Java/Others)
Memory Limit: 524288/524288 K (Java/Others)

Problem Description
Recently, TeaTree acquire new knoledge gcd (Greatest Common Divisor), now she want to test you.
As we know, TeaTree is a tree and her root is node 1, she have n nodes and n-1 edge, for each node i, it has it’s value v [ i ] .
For every two nodes i and j (i is not equal to j), they will tell their Lowest Common Ancestors (LCA) a number : g c d ( v [ i ] , v [ j ] ) .
For each node, you have to calculate the max number that it heard. some definition:
In graph theory and computer science, the lowest common ancestor (LCA) of two nodes u and v in a tree is the lowest (deepest) node that has both u and v as descendants, where we define each node to be a descendant of itself.

Input
On the first line, there is a positive integer n, which describe the number of nodes.
Next line there are n-1 positive integers f [ 2 ] , f [ 3 ] , , f [ n ] , f [ i ] describe the father of node i on tree.
Next line there are n positive integers v [ 2 ] , v [ 3 ] , , v [ n ] , v [ i ] describe the value of node i.
n <= 100000 , f [ i ] < i , v [ i ] <= 100000

Output
Your output should include n lines, for i-th line, output the max number that node i heard.
For the nodes who heard nothing, output -1.

Sample Input
4
1 1 3
4 1 6 9

Sample Output
2
-1
3
-1

思路:因为每个数的因子只有100多个,所以看似暴力的做法其实可以过。从大神那学习了一种写法,bitset动态存储每个子树的所有的因子数。

把每个数当成一个bit,然后把约数反向存入bitset,这样就可以用bitset的_Find_first()函数找到最低位的1,即最大的约数。

PS:如果这棵树是一条链的话,空间可能就炸了。所以还是建议用启发式合并。。

#include<bits/stdc++.h>
using namespace std;
const int MAX=1e5+10;
const int N=1e5;
typedef long long ll;
vector<int>e[MAX];
vector<int>d[MAX];
int a[MAX],ans[MAX];
bitset<MAX>*b[MAX];
void dfs(int k)
{
    b[k]=new bitset<MAX>(0);//动态开内存
    for(int j=0;j<d[a[k]].size();j++)(*b[k])[N-d[a[k]][j]]=1;//将a[k]的约数反着存入节点
    for(int i=0;i<e[k].size();i++)
    {
        int nex=e[k][i];
        dfs(nex);
        int x=((*b[k])&(*b[nex]))._Find_first();//找到bitset里面最低位的1
        (*b[k])|=(*b[nex]); //合并儿子节点
        ans[k]=max(ans[k],N-x);
        delete b[nex];      //删除儿子节点
    }
}
int main()
{
    for(int i=1;i<=1e5;i++)
    for(int j=i;j<=1e5;j+=i)d[j].push_back(i);//预处理约数
    int n;
    scanf("%d",&n);
    for(int i=2;i<=n;i++)
    {
        int x;
        scanf("%d",&x);
        e[x].push_back(i);
    }
    for(int i=1;i<=n;i++)scanf("%d",&a[i]);
    memset(ans,-1,sizeof ans);
    dfs(1);
    for(int i=1;i<=n;i++)printf("%d\n",ans[i]);
    return 0;
}

猜你喜欢

转载自blog.csdn.net/Mitsuha_/article/details/81951068